<launch>
    <!--& settings -->
    <arg name="sim_unpause_timeout" default="0.5"/>

    <arg name="name"/>
    <arg name="velocity" default="false"/>
    <arg name="force" default="false"/>
    <arg name="torque" default="false"/>
    <arg name="acc_duration" default="0"/>

    <!--& load world and model -->
    <include file="$(find trolley_simulation)/launch/trolley.launch">
        <arg name="gui" value="0"/>
        <arg name="paused" value="1"/>
        <arg name="enable_test" value="true"/>
        <arg name="enable_rolling_friction" value="true"/>
    </include>

    <include file="$(find trolley_simulation)/launch/gazebo_unpause_simulation.launch">
        <arg name="timeout" value="$(arg sim_unpause_timeout)"/>
    </include>

    <!--& handle force -->
    <group if="$(arg force)">
        <node name="handle_force_measurement_publisher" pkg="trolley_tests" type="handle_force_measurement_publisher.py" />
    </group>

    <!--& motor -->
    <group if="$(eval velocity and not force)">
        <include file="$(find trolley_controller)/launch/wheel_joint_effort_plugin.launch"/>
        <node name="motor_command_publisher" pkg="trolley_tests" type="motor_command_publisher.py">
            <param name="duration" value="$(arg acc_duration)" unless="$(arg torque)"/>
        </node>
    </group>

    <!--& tests -->
    <test test-name="test_rolling_friction_plugin_normal_force_$(arg name)" pkg="trolley_tests" type="test_rolling_friction_plugin_normal_force.py">
        <param name="velocity" value="$(arg velocity)"/>
        <param name="force" value="$(arg force)"/>
        <param name="torque" value="$(arg torque)"/>
        <param name="acc_duration" value="$(arg acc_duration)"/>
    </test>
</launch>
